;
;       Reaction Timer from the MK14 Manual
;
;       after display lights up press 'MEM'
;

#define DatPtr(x)       ((x)+1)         ; useful SC/MP macros
#define High(x)         ((x)/256)
#define Low(x)          ((x) & 255)

Disp    .equ    0D00h
Cycles  .equ    500
Ram     .equ    0F00h
Adlh    .equ    5
Adl     .equ    12
Adh     .equ    14
Dispa   .equ    015Ah

        .org    0F20h

        ldi     0Dh                     ; initialise P1 & P2 (added)
        xpah    1
        ldi     0
        xpal    1
        ldi     0Fh
        xpah    2
        ldi     0
        xpal    2

Begin:  ldi     High(Dispa)
        xpah    3
        ldi     Low(Dispa)-1
        xpal    3
        ld      Adlh(2)
Wait:   xae
        dly     Cycles/4
        ccl
        ade
        jp      Wait
        st      +3(1)
        lde
        st      Adl(2)
        st      Adh(2)
Time:   ldi     (Cycles-151-13)/2
        dly     0
        scl
        ld      Adl(2)
        dae
        st      Adl(2)
        ld      Adh(2)
        dae
        st      Adh(2)
        lde
        ccl
        cad     3(1)
        jz      Time
Stop:   xppc    3
        jmp     Stop
        jmp     Begin
      
        .end

